"{ Package: 'jv:calipel/s' }"

BenchmarkReport subclass:#BenchmarkReportText
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'CalipeL-S-Core-Reports'
!


!BenchmarkReportText methodsFor:'formatting'!

format: anObject width: width align: align
    | string |

    string := anObject printString. 
    align == #left ifTrue:[
        stream nextPutAll: string.
        stream next: ((width - string size) max: 0) put: Character space.
        ^self.
    ].
    align == #right ifTrue:[
        stream next: ((width - string size) max: 0) put: Character space.
        stream nextPutAll: string.
        ^self.
    ].
    align == #center ifTrue:[
        stream next: (((width - string size) max: 0) / 2 floor) put: Character space.
        stream nextPutAll: string.
        stream next: (((width - string size) max: 0) / 2 ceiling) put: Character space.
        ^self.
    ]

    "Created: / 31-05-2013 / 12:09:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkReportText methodsFor:'writing'!

writeFooter

    "Modified: / 11-06-2013 / 23:28:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

writeHeader
    stream 
        nextPutAll: 'Generated at :';
        nextPutAll: Date today printString;
        nextPutAll: ' ';
        nextPutAll: Time now printString;
        cr;
        cr.

    "Modified: / 11-06-2013 / 23:28:37 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

writeOutcome: outcome
    self format: outcome benchmark selector width: 15 align: #right.
    stream nextPutAll: ' : '.
    self format: outcome time width: 5 align: #right.
    stream nextPutAll: ' [ms]'.
    stream cr.

    "Created: / 11-06-2013 / 23:24:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

writeOutcomes
    | class |

    class := nil.
    result outcomesDo:[:outcome |
        outcome benchmark instance class == class ifFalse:[
            class := outcome benchmark instance class.
            stream nextPutAll: '== ', class name , ' =='; cr.
        ].
        self writeOutcome: outcome
    ].
    stream cr.

    "Created: / 11-06-2013 / 23:24:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkReportText class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
!

version_MC
    ^ 'CalipeL_S-Core-JanVrany.7 5c300a20-c9d7-11e2-a959-606720e43e2c 2013-05-31T10:49:17 JanVrany'
! !

