#!/bin/sh

DEBUGGER=
PROFILER=
SMALLTALK_OPTS=
PROFILER_OPTS=
VM_OPTS=

if [ "$1" = "--help" ]
then
    echo <<ENDHELP
  --gdb ................... run benchmark under gdb debugger. Start with 
                            (gdb) r -I -f "$DIR/benchmark-runner.st" -b ... 
  --cgdb .................. run benchmark under cgdb debugger
  --callgrind ............. run benchmark under callgrind profiler. 
ENDHELP
    "$DIR/../../projects/smalltalk/stx" -I  -f "$DIR/benchmark-runner.st" ${1+"$@"}
# .........................
fi


while [ ! -z "$1" ]; do	
    case "$1" in 
        --gdb)
            DEBUGGER=gdb
            ;;
        --cgfb)
            DEBUGGER=gdb
            ;;
        --callgrind)
            #PROFILER="/usr/local/bin/valgrind -v -v -d --tool=callgrind --instr-atstart=no"
            PROFILER="/usr/local/bin/valgrind -v --smc-check=all-non-file --tool=callgrind --instr-atstart=no"
            PROFILER="valgrind -v --smc-check=all-non-file --tool=callgrind --instr-atstart=no"
            #PROFILER_OPTS=--callgrind                    
            ;;
        -T*)
            VM_OPTS="$VM_OPTS $1"
            ;;
        -M*)
            VM_OPTS="$VM_OPTS $1"
            ;;
        *)
            SMALLTALK_OPTS="$SMALLTALK_OPTS $1"    
            ;;
    esac
    shift
done




DIR=`dirname $0`
if [ ! -z "$DEBUGGER" ]; then
    exec $DEBUGGER $DIR/../../../stx/projects/smalltalk/stx 
fi
if [ ! -z "$PROFILER" ]; then
    exec $PROFILER $DIR/../../../stx/projects/smalltalk/stx \
        $VM_OPTS \
        -I -f "$DIR/benchmark-runner.st" \
        $SMALLTALK_OPTS       
fi

    
exec "$DIR/../../../stx/projects/smalltalk/stx" \
    $VM_OPTS \
    -I  -f "$DIR/benchmark-runner.rc" \
    $SMALLTALK_OPTS

