"
Copyright 2008-2010 Isaac Gouy
Copyright (C) 2013 Stefan Marr (modification for SMark)
Copyright (C) 2013 Jan Vrany (modification for CalipeL/S)

============================================================================
Revised BSD license

This is a specific instance of the Open Source Initiative (OSI) BSD license
template http://www.opensource.org/licenses/bsd-license.php


Copyright 2008-2010 Isaac Gouy
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

   Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.

   Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.

   Neither the name of 'The Computer Language Benchmarks Game' nor the name of
   'The Computer Language Shootout Benchmarks' nor the name 'nanobench' nor
   the name 'bencher' nor the names of its contributors may be used to endorse
   or promote products derived from this software without specific prior
   written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 'AS IS'
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"
"{ Package: 'jv:calipel/s/benchmarks/game' }"

Object subclass:#BenchmarkGameSuite
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'CalipeL-S-Benchmarks-Game'
!

BenchmarkGameSuite comment:''
!

!BenchmarkGameSuite class methodsFor:'documentation'!

copyright
"
Copyright 2008-2010 Isaac Gouy
Copyright (C) 2013 Stefan Marr (modification for SMark)
Copyright (C) 2013 Jan Vrany (modification for CalipeL/S)

============================================================================
Revised BSD license

This is a specific instance of the Open Source Initiative (OSI) BSD license
template http://www.opensource.org/licenses/bsd-license.php


Copyright 2008-2010 Isaac Gouy
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

   Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.

   Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.

   Neither the name of 'The Computer Language Benchmarks Game' nor the name of
   'The Computer Language Shootout Benchmarks' nor the name 'nanobench' nor
   the name 'bencher' nor the names of its contributors may be used to endorse
   or promote products derived from this software without specific prior
   written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 'AS IS'
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."

    "Created: / 10-06-2013 / 22:14:09 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkGameSuite class methodsFor:'instance creation'!

new
    "return an initialized instance"

    ^ self basicNew initialize.
! !

!BenchmarkGameSuite class methodsFor:'transporter'!

transportersForFileOutMenu
	^ { (Smalltalk at: #Transporter ifAbsent: [^#()])
			forPackage: (PackageInfo named: 'CL-Benchmarks-Game') }
! !

!BenchmarkGameSuite methodsFor:'benchmarking'!

benchBinaryTrees
	| bench problemSize |
	bench := BenchmarkGameBinaryTrees new.
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							  ifNil: [ BenchmarkGameBinaryTrees defaultProblemSize ].
	^ bench binarytrees: problemSize to: (TextStream with: String new).
!

benchChameleons
	| result problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								  ifNil: [ BenchmarkGameChameleons defaultProblemSize ].
	result := BenchmarkGameChameleons chameneos: problemSize.
	
	"Result should be 2*numberOfProcesses (as far as I understand the benchmark)"
	self flag: 'TODO adapt once verification is supported'.
	result = (2 * problemSize) ifFalse: [
		Error signal: (BenchmarkGameChameleons name, ' benchmark failed. Input: ', 
								 problemSize asString, ' Output: ', result asString).
	].
!

benchChameneosRedux
    "Not yet updated to CalipeL-S"

"/        | result report problemSize |
"/        problemSize := self problemSize ifNotNil: [:ps | ps ]
"/                                                                  ifNil: [ BenchmarkGameChameneosRedux defaultProblemSize ].
"/        report := TextStream with: String new.
"/        result := BenchmarkGameChameneosRedux new runBenchMark: problemSize on: report.
"/        
"/        "Result should be 2*problemSize"
"/        self flag: 'TODO: adapt once verification is supported'.
"/        result = (2 * problemSize) ifFalse: [
"/                Error signal: self class name, ' benchmark failed. Input: ',
"/                                                                 runner processes asString, ' Output: ', result asString  ].
"/

    "Modified (comment): / 10-06-2013 / 22:16:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

benchFannkuchRedux
   | f problemSize |
	problemSize := self problemSize
		ifNotNilDo: [:ps | ps ]
		ifNil: [ BenchmarkGameFannkuchRedux defaultProblemSize ].
   f := BenchmarkGameFannkuchRedux fannkuchRedux: problemSize to: (TextStream with: String new).
   
	" the output should only be done by some reporter"
	"ScriptConsole print: 'Pfannkuchen(', problemSize asString , ') = ', f asString."
   ^f
!

benchFasta
	| out problemSize |
	out := TextStream with: String new.
	problemSize := self problemSize
		ifNotNilDo: [:ps | ps ]
		ifNil:      [ BenchmarkGameFasta defaultProblemSize ].  
	BenchmarkGameFasta fasta: problemSize to: out.
!

benchKNucleotide
	| bench input result problemSize output |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							            ifNil:    [ BenchmarkGameKNucleotide defaultProblemSize ].
	
	bench := BenchmarkGameKNucleotide new.
	input := ReadStream on: (BenchmarkGameFastaCache forFasta: problemSize).
	result := TextStream with: String new.
	output := bench knucleotide5From: input to: result.
	
	^ output
!

benchMandelbrot
	| result bench problemSize |
	bench := BenchmarkGameMandelbrot new.
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							                 ifNil:    [ BenchmarkGameMandelbrot defaultProblemSize ].
	result := bench mandelbrot2: problemSize.
	result reset.
	^ result contents
!

benchMeteor
	| problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								  ifNil: [ BenchmarkGameMeteor defaultProblemSize ].
	^ BenchmarkGameMeteor meteor: problemSize.
!

benchNBody
	| problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								  ifNil: [ BenchmarkGameNBody defaultProblemSize ].
	BenchmarkGameNBody nbody: problemSize.
!

benchPiDigits
	| problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								  ifNil: [ BenchmarkGamePiDigits defaultProblemSize ].
	^ BenchmarkGamePiDigits piDigits: problemSize.
!

benchRegexDNA
	| problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								  ifNil: [ BenchmarkGameRegexDNA defaultProblemSize ].
	
	BenchmarkGameRegexDNA regexdna: problemSize
!

benchReverseComplement
	| problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								  ifNil: [ BenchmarkGameReverseComplement defaultProblemSize ].
	
	BenchmarkGameReverseComplement revcomp: problemSize
!

benchSpectralNorm
	| bench problemSize |
	bench := BenchmarkGameSpectralNorm new.
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							                 ifNil:    [ BenchmarkGameSpectralNorm defaultProblemSize ].
	^ bench spectralnorm: problemSize.
!

benchThreadRing
	| problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								  ifNil: [ BenchmarkGameThreadRing defaultProblemSize ].
	^ BenchmarkGameThreadRing threadring: problemSize.
! !

!BenchmarkGameSuite methodsFor:'initialization'!

initialize
    "Invoked when a new instance is created."

    "/ please change as required (and remove this comment)

    "/ super initialize.   -- commented since inherited method does nothing
! !

!BenchmarkGameSuite class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

