class Settings::LanguageImplementationsController < SettingsController

  def index
    @impl = LanguageImplementation.new
  end

  def create
    @impl = LanguageImplementation.new(language_impl_params) 

    if @impl.save
      flash[:success] = "Language implementation #{@impl.name} successfully created"
      redirect_to action: :index
    else
      flash[:failure] = "There were some errors" 
      render "index"
    end
  end

  def destroy
    @impl = LanguageImplementation.find(params[:id]) 

    if @impl.destroy
      flash[:success] = "Language implementation #{@impl.name} successfully deleted"
    else
      flash[:error] = "Could not delete #{@impl.name} language"
    end

    redirect_to action: :index
  end

  private

  def language_impl_params
    params.require(:language_implementation).permit(:name, :language_id)
  end
end
