require 'bundler/capistrano'
set :rvm_ruby_string, '2.0.0'
require 'rvm/capistrano'

set :application, "calipel"

set :scm, :mercurial 
set :repository,  "ssh://hg@bitbucket.org/janvrany/jv-calipel"

set :deploy_via, :remote_cache
set :deploy_to, "/home/hlopkmar/calipel"
set :deploy_subdir, "web"

server "swing.fit.cvut.cz", :app, :web, :db, primary: true
set :user, "hlopkmar"
set :use_sudo, false

set :default_environment, {
  'PATH' => "/home/hlopkmar/.rvm/gems/ruby-2.0.0-p195/bin:/home/hlopkmar/.rvm/bin:$PATH"
}

after "deploy:finalize_update", "deploy:db:symlink_db"
after "deploy:finalize_update", "deploy:symlink_htaccess"
# if you want to clean up old releases on each deploy uncomment this:
# after "deploy:restart", "deploy:cleanup"

namespace :deploy do
  namespace :db do
    desc "Link our sqlite db from shared directory"
    task :symlink_db  do
      run "ln -nfs #{shared_path}/production.sqlite3  #{release_path}/db/production.sqlite3"
    end
  end   

  task :start do ; end
  task :stop do ; end

  task :restart, :roles => :app, :except => { :no_release => true } do
    run "touch #{File.join(current_path,'tmp','restart.txt')}"
  end

  desc "Link htaccess from shared directory"
  task :symlink_htaccess  do
    run "ln -nfs #{shared_path}/htaccess  #{release_path}/public/.htaccess"
  end
end 
